;
; Plots maps of chronology location
;
ncid=ncdf_open('tree_dens_su1400.nc')
ncdf_diminq,ncid,'station',dummy,nstat
ncdf_varget,ncid,'country',country
ncdf_varget,ncid,'tree',tree
ncdf_varget,ncid,'latitude',ylat
ncdf_varget,ncid,'longitude',xlon
ncdf_close,ncid
;
loadct,39
def_1color,r,g,b,10,color='red'
multi_plot,nrow=4,ncol=2
if !d.name eq 'X' then begin
  window,xsize=650,ysize=950
endif else begin
  device,xsize=15,xoffset=3
  device,ysize=24,yoffset=2
endelse
;
wlims=0.
elims=180.
oxs=0.5*(wlims+elims)
;
map=def_map(/npolar)  &  map.limit(0)=30.
coast=def_coast(/off)
labels=def_labels(/off)  &  labels.gridon=1  &  labels.dlon=90.
;
restore,filename='reglists.idlsave'
for i = 0 , nreg-1 do begin
;
pause
map.limit(1)=wlims
map.limit(3)=elims
map.origx=oxs
inter_boxfd,/nodata,map=map,coast=coast,labels=labels,$
  title=regname(i)+'  n='+string(ntree(i),format='(I3)')
map_continents,/coasts,color=!p.color,mlinethick=0.5
map_continents,/countries,color=!p.color,mlinestyle=1,mlinethick=0.5
;
x=xlon(treelist(0:ntree(i)-1,i))
y=ylat(treelist(0:ntree(i)-1,i))
cpl_usersym,/circle,/fill
plots,x,y,psym=8,color=10,symsize=0.5,noclip=0
cpl_usersym,/circle
plots,xlon,ylat,psym=8,thick=1,symsize=0.5,noclip=0
;
endfor
;
end
